<template functional>
  <div
    :ref="data.ref"
    class="[ a-icon-dropdown-ui ] flex items-center"
    :class="[data.class, data.staticClass]"
    :style="[data.style, data.staticStyle]"
    :data-panel-position="props.position"
    v-bind="data.attrs"
    v-on="listeners"
  >
    <!-- Profile dropdown -->
    <div class="relative">
      <div>
        <!--
          @slot The icon that reveals the panel.
        -->
        <slot name="icon" />
      </div>

      <transition
        enter-active-class="transition ease-out duration-200"
        enter-class="transform opacity-0 scale-95"
        enter-to-class="transform opacity-100 scale-100"
        leave-active-class="transition ease-in duration-75"
        leave-class="transform opacity-100 scale-100"
        leave-to-class="transform opacity-0 scale-95"
      >
        <div v-show="props.showPanel" class="[ panel-outer-wrapper ]">
          <div
            class="[ panel-inner-wrapper ]"
            role="menu"
            aria-orientation="vertical"
            aria-labelledby="user-menu"
          >
            <!--
              @slot The dropdown panel entries.
            -->
            <slot name="panel" />
          </div>
        </div>
      </transition>
    </div>
  </div>
</template>

<script>
export default {
  name: 'AIconDropdownUi',
  props: {
    /** Panel position relative to the icon (left | center | right). */
    position: {
      type: String,
      default: 'right',
      validator: value => ['left', 'center', 'right'].includes(value),
    },
    /** Toggles the panel visibility. */
    showPanel: {
      type: Boolean,
      default: false,
    },
  },
};
</script>

<style scoped>
/* prettier-ignore */
.a-icon-dropdown-ui {
  --a-icon-dropdown-ui--panel--def-mt: 0.5rem; /* theme('spacing.2') */
  --a-icon-dropdown-ui--panel--def-min-w: 12rem; /* theme('minWidth.xl') */
  --a-icon-dropdown-ui--panel--def-bg-color: hsl(0, 0%, 100%); /* theme('colors.white') */
  --a-icon-dropdown-ui--panel--def-rounded: 0.25rem; /* theme('borderRadius.default') */
}

/* prettier-ignore */
.a-icon-dropdown-ui .panel-outer-wrapper,
.a-icon-dropdown-ui .panel-inner-wrapper {
  border-radius: var(--a-icon-dropdown-ui--panel--rounded, var(--a-icon-dropdown-ui--panel--def-rounded));
}

/* prettier-ignore */
.a-icon-dropdown-ui .panel-outer-wrapper {
  position: absolute;
  margin-top: var(--a-icon-dropdown-ui--panel--mt, var(--a-icon-dropdown-ui--panel--def-mt));
  box-shadow: 0 10px 15px -3px rgba(0, 0, 0, 0.1), 0 4px 6px -2px rgba(0, 0, 0, 0.05); /* theme('boxShadow.lg') */
  z-index: 50; /* theme('zIndex.50') */
}
.a-icon-dropdown-ui[data-panel-position='left'] .panel-outer-wrapper {
  transform-origin: top left;
  left: 0;
}
.a-icon-dropdown-ui[data-panel-position='center'] .panel-outer-wrapper {
  transform-origin: top left;
  left: 50%;
  transform: translateX(-50%);
}
.a-icon-dropdown-ui[data-panel-position='right'] .panel-outer-wrapper {
  transform-origin: top right;
  right: 0;
}

/* prettier-ignore */
.a-icon-dropdown-ui .panel-inner-wrapper {
  min-width: var(--a-icon-dropdown-ui--panel--min-w, var(--a-icon-dropdown-ui--panel--def-min-w));
  padding-top: 0.25rem; /* theme('spacing.1') */
  padding-bottom: 0.25rem; /* theme('spacing.1') */
  background-color: var(--a-icon-dropdown-ui--panel--bg-color, var(--a-icon-dropdown-ui--panel--def-bg-color));
  box-shadow: 0 0 0 1px rgba(0, 0, 0, 0.05); /* theme('boxShadow.xs') */
}
</style>
